SystemOrganization addCategory: #GODProcessorsTests!

TestCase subclass: #PCSStatisticsTests
	instanceVariableNames: 'pcsStatistics aCollection aGODCollection invalidCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessorsTests'!

!PCSStatisticsTests methodsFor: 'initialize-release' stamp: 'TD 10/15/2014 11:44'!
setUp
	"Define local objects for tests"
	|godData|
	pcsStatistics := PCSStatisticsCalculator new.
	aCollection := #(1 3 3 4 4) asBag.
	invalidCollection := #(1 3  'a' 4 4) asBag.
	aGODCollection := Bag new.
	godData := GODData new.
	godData
		title: 'title1';
		width: 1.
	aGODCollection add: godData.
	godData := GODData new.
	godData
		title: 'title2';
		width: 2.
	aGODCollection add: godData.
	godData := GODData new.
	godData
		title: 'title3';
		width: 3.
	aGODCollection add: godData.
		
! !

!PCSStatisticsTests methodsFor: 'testsPass' stamp: 'TD 10/7/2014 19:02'!
testAverage
	"test average"
	self assert: (pcsStatistics average: aCollection) = 3.
	! !

!PCSStatisticsTests methodsFor: 'testsPass' stamp: 'TD 10/15/2014 10:47'!
testAverageKey
	"test average given the key width"
	self assert: (pcsStatistics average: aGODCollection key: [:x | x width]) = 2.
	
	! !

!PCSStatisticsTests methodsFor: 'testsPass' stamp: 'TD 10/15/2014 10:33'!
testCountInOcurrencesOf
	"test mean given the key width"
	|aString aWord|
	aString := 'teste teste2 e ateste'.
	aWord := 'teste'.
	self assert: (pcsStatistics countIn: aString ocurrencesOf: aWord) = 1.! !

!PCSStatisticsTests methodsFor: 'testsPass' stamp: 'TD 10/14/2014 11:15'!
testMedian
	"test median"
	self assert: (pcsStatistics median: aCollection) = 3.
	! !

!PCSStatisticsTests methodsFor: 'testsPass' stamp: 'TD 10/15/2014 13:15'!
testMedianKey
	"test mean given the key width"
	self assert: (pcsStatistics median: aGODCollection key: [:x | x width]) = 2.! !

!PCSStatisticsTests methodsFor: 'testFail' stamp: 'TD 10/15/2014 10:39'!
testNaN
	self should: [pcsStatistics average: invalidCollection.] raise: Error! !

!PCSStatisticsTests methodsFor: 'testsPass' stamp: 'TD 10/14/2014 13:10'!
testStd
	"test standart deviation"
	self assert: (pcsStatistics std: aCollection) = (12/5) sqrt.! !

!PCSStatisticsTests methodsFor: 'testsPass' stamp: 'TD 10/14/2014 13:11'!
testStdKey
	"test mean given the key width"
	self assert: (pcsStatistics std: aGODCollection key: [:x | x width]) = (2/3) sqrt.! !

!PCSStatisticsTests methodsFor: 'testsPass' stamp: 'TD 10/15/2014 13:17'!
testVar
	"test standart deviation"
	self assert: (pcsStatistics var: aCollection) = (12/5).! !

!PCSStatisticsTests methodsFor: 'testsPass' stamp: 'TD 10/15/2014 13:17'!
testVarKey
	"test mean given the key width"
	self assert: (pcsStatistics var: aGODCollection key: [:x | x width]) = (2/3).! !
